import com.ibm.uddi.*;
import com.ibm.uddi.response.*;
import com.ibm.uddi.client.*;
import com.ibm.uddi.datatype.*;
import com.ibm.uddi.datatype.service.*;
import com.ibm.uddi.datatype.binding.*;
import com.ibm.uddi.datatype.tmodel.*;
import com.ibm.uddi.util.*;

import java.util.*;
import java.net.*;

public class ListServices {

	protected String serviceProvider = null;

	public static void main(String args[]) throws Exception {
		ListServices ls = new ListServices();
		ls.parseArgs(args);
		ls.listServiceDetails();
	}


	public void parseArgs(String args[]) {
		serviceProvider = args[0];
	}

	public void listServiceDetails() throws Exception {
		UDDIProxy up = new UDDIProxy(
			new URL("http://www-3.ibm.com/services/uddi/testregistry/inquiryapi"),
			new URL("http://www.ibm.com/services/uddi/testregistry/protect/publishapi"),
			new org.apache.soap.transport.http.SOAPHTTPConnection());

                BusinessList bl = up.find_business(serviceProvider, null, 0);
                Vector businessInfos = bl.getBusinessInfos().getBusinessInfoVector();

                Enumeration enum = businessInfos.elements();
                while (enum.hasMoreElements()) {
                	BusinessInfo bi = (BusinessInfo)enum.nextElement();
                	System.out.println("found a business : "+bi.getNameString());

                	Vector serviceInfos = bi.getServiceInfos().getServiceInfoVector();
                	Enumeration enum1 = serviceInfos.elements();

                	while (enum1.hasMoreElements()) {
                		ServiceInfo si = (ServiceInfo)enum1.nextElement();
                                System.out.println("\tfound service name : "+si.getNameString());
                                System.out.println("\tfound service key : "+si.getServiceKey());

                                ServiceDetail sd = up.get_serviceDetail(si.getServiceKey());
                                Vector businessServices = sd.getBusinessServiceVector();

                                Enumeration enum2 = businessServices.elements();
                                while (enum2.hasMoreElements()) {
                                	BusinessService bs = (BusinessService)enum2.nextElement();
					Vector bindingTemplates = bs.getBindingTemplates().getBindingTemplateVector();

					Enumeration enum3 = bindingTemplates.elements();
					while (enum3.hasMoreElements()) {
						BindingTemplate bt = (BindingTemplate)enum3.nextElement();
                                                AccessPoint ap = bt.getAccessPoint();
                                                System.out.println("\t\t\tfound access point : "+ap.getText());
                                                System.out.println("\t\t\tfound URL type : "+ap.getURLType());

						Vector tModelInfos = bt.getTModelInstanceDetails().getTModelInstanceInfoVector();

						Enumeration enum4 = tModelInfos.elements();
						while (enum4.hasMoreElements()) {
							TModelInstanceInfo tModel = (TModelInstanceInfo)enum4.nextElement();
							String tModelKey = tModel.getTModelKey();
							System.out.println("\t\t\t\tfound tmodel : "+tModelKey);
							try {
								System.out.println("\t\t\t\tfound overview doc : "+tModel.getInstanceDetails().getOverviewDoc().getOverviewURLString());
							} catch (NullPointerException n) {} // may not have any instance details
						}
					}

					Vector keyedReferences = new Vector();
					try {
						keyedReferences = bs.getCategoryBag().getKeyedReferenceVector();
					} catch (NullPointerException n) {} //may not have any categories

					Enumeration enum5 = keyedReferences.elements();
                                        while (enum5.hasMoreElements()) {
                                        	KeyedReference kr = (KeyedReference)enum5.nextElement();
                                        	System.out.println("found a keyed reference of name : "+kr.getKeyName());
                                        	System.out.println("found a keyed reference of value : "+kr.getKeyValue());
                                        	System.out.println("found a keyed reference of tmodel: "+kr.getTModelKey());

                                        	String tMKey = kr.getTModelKey();
                                        	TModelDetail td = up.get_tModelDetail(tMKey);
                                        	Vector tModels = td.getTModelVector();
                                        	Enumeration enum6 = tModels.elements();
                                        	while (enum6.hasMoreElements()) {
                                        		TModel tm = (TModel)enum6.nextElement();
                                        		System.out.println("tmodel name is : "+tm.getNameString());
                                        	}
                                        }
                                }
                	}
                }
	}
}
