import java.net.*;
import java.util.*;

import com.ibm.uddi.*;
import com.ibm.uddi.client.*;
import com.ibm.uddi.response.*;
import com.ibm.uddi.datatype.business.*;
import com.ibm.uddi.datatype.*;
import com.ibm.uddi.util.*;

public class PublishServices {

	public static void main(String args[]) throws Exception {

		System.setProperty("java.protocol.handler.pkgs", "com.sun.net.ssl.internal.www.protocol");
		java.security.Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());

		UDDIProxy up = new UDDIProxy(
			new URL("http://www-3.ibm.com/services/uddi/testregistry/inquiryapi"),
			new URL("https://www-3.ibm.com/services/uddi/testregistry/protect/publishapi"),
			new org.apache.soap.transport.http.SOAPHTTPConnection());

		AuthToken at = up.get_authToken("myuserid", "mypassword");
		String ais = at.getAuthInfoString();

		KeyedReference kr = new KeyedReference("Other Accounting Services", "541219");
		// the following UUID references the NAICS TModel key
		kr.setTModelKey("UUID:C0B9FE13-179F-413D-8A5B-5004DB8E5BB2");
		Vector krVector = new Vector();
		krVector.addElement(kr);

		CategoryBag cb = new CategoryBag();
		cb.setKeyedReferenceVector(krVector);

		BusinessEntity be = new BusinessEntity();
		be.setName(new Name("John's Balance Business"));
		be.setDefaultDescriptionString("A business doing balance stuff.");
		be.setCategoryBag(cb);

		Vector beVector = new Vector();
		beVector.addElement(be);

		try {
			up.save_business(ais, beVector);
			System.out.println("Business saved.");
		} catch (UDDIException x) {
			System.out.println("Caught exception : "+x.getFaultString());
		}
	}
}
